#include <catch.hpp>

#include <RevisionInfo.hpp>

#include <pastis_git_revision.hpp>
#include <pastis_version.hpp>

TEST_CASE("RevisionInfo", "[utils]") {

  SECTION("checking pastis version") {
    REQUIRE( (RevisionInfo::version() == PASTIS_VERSION) );
  }
  SECTION("checking git info") {
#ifdef HAS_PASTIS_GIT_INFO
    REQUIRE( (RevisionInfo::hasGitInfo() == true) );
    REQUIRE( (RevisionInfo::gitTag() == PASTIS_GIT_TAG) );
    REQUIRE( (RevisionInfo::gitHead() == PASTIS_GIT_HEAD) );
    REQUIRE( (RevisionInfo::gitHash() == PASTIS_GIT_HASH) );
    REQUIRE( (RevisionInfo::gitIsClean() == PASTIS_GIT_IS_CLEAN) );

    SECTION("checking tag") {
      std::string tag_from_version = "v";
      tag_from_version += std::string(PASTIS_VERSION);
      REQUIRE( tag_from_version == RevisionInfo::gitTag());
    }
#else
    REQUIRE( (RevisionInfo::hasGitInfo() == false) );
    REQUIRE( (RevisionInfo::gitTag() == "unknown tag") );
    REQUIRE( (RevisionInfo::gitHead() == "unknown head") );
    REQUIRE( (RevisionInfo::gitHash() == "unknown hash") );
    REQUIRE( (RevisionInfo::gitIsClean() == false) );
#endif
  }
}
